/*******************************************\
 *  this code is not part of the exercise  *
\*******************************************/

/*
 * Copyright 1993-2010 NVIDIA Corporation.  All rights reserved.
 *
 * NVIDIA Corporation and its licensors retain all intellectual property and
 * proprietary rights in and to this software and related documentation.
 * Any use, reproduction, disclosure, or distribution of this software
 * and related documentation without an express license agreement from
 * NVIDIA Corporation is strictly prohibited.
 *
 * Please refer to the applicable NVIDIA end user license agreement (EULA)
 * associated with this source code for terms and conditions that govern
 * your use of this NVIDIA software.
 *
 */


#ifndef __CPU_BITMAP_H__
#define __CPU_BITMAP_H__

#include "opengl_includes.h"


struct pixelRGBA8888
{

	pixelRGBA8888(const unsigned char Red, const unsigned char Green, const unsigned char Blue, const unsigned char Alpha)
	{
		r = Red;
		g = Green;
		b = Blue;
		a = Alpha;
	}

	pixelRGBA8888(const unsigned char Red, const unsigned char Green, const unsigned char Blue)
	{
		r = Red;
		g = Green;
		b = Blue;
		a = 255;
	}

	pixelRGBA8888(const unsigned char Intensity)
	{
		r = Intensity;
		g = Intensity;
		b = Intensity;
		a = 255;
	}

	pixelRGBA8888(void)
	{
		r = 0;
		g = 0;
		b = 0;
		a = 0;
	}

	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;
};

struct CPUBitmap 
{
    pixelRGBA8888   *pixels;
    int				x, y;

    CPUBitmap( int width, int height ) 
	{
        pixels = new pixelRGBA8888[width * height];
        x = width;
        y = height;
    }

    ~CPUBitmap() 
	{
        delete [] pixels;
    }

    pixelRGBA8888* get_ptr( void ) const   
	{ 
		return pixels; 
	}
    
	long get_image_size( void ) const
	{
		return x * y * sizeof(pixelRGBA8888); 
	}

    void draw( ) 
	{
		glClearColor( 0.0, 0.0, 0.0, 1.0 );
		glClear( GL_COLOR_BUFFER_BIT );
		glDrawPixels( x, y, GL_RGBA, GL_UNSIGNED_BYTE, pixels );
    }

};

#endif  // __CPU_BITMAP_H__
